{Programme name: LINK-UP
  Creation date: July 1996
       Function: Transfers editor files and programme files to and fro from
       		 the casio graphical calculators (models cfx-9800/9850).

This programme is (C)opyright 1996 by Wallace Wadge. All rights reserved.
Released to the public as freeware.

Tech doc:
All I/O is done by the library pcl4p, siogetc fetches a char and sioputc
transmits a char. The calculator's format is described in readme.doc.
The percentage bars are done by the library of tvtools (saved me some work).

To summerise to compile this programme you need tvtools and pcl4p}

{$M 16384,8192,655360}
{$X+,S+,F-,B+,R+,V-,N+,E+}  {<-- Various crap}

{.$DEFINE LOCAL}  {<--- If defined, will not perform fades. A parameter of
/nofade has the same effect}
uses crt, Dos, Objects, Drivers, Memory, Views, Menus, Dialogs,
  StdDlg, MsgBox, App, casioEdi, PCL4P, tvdialog, tvconst, validate,
  strings, tvobject, scr, colorsta, textview;

type
  Pcasioapp = ^Tcasioapp;
  Tcasioapp = object(TApplication)
    constructor Init;        {main handler}
    procedure idle; virtual; {updates status line mainly}
    procedure HandleEvent(var Event: TEvent); virtual; {Main central handler}
    procedure InitMenuBar; virtual;  {Menu bar}
    procedure InitStatusLine; virtual;	{Status bar}
    procedure OutOfMemory; virtual;  {Called when there isn't enough memory}
    procedure UploadDialog (editor: boolean); {Constructs the upload dialog}
    procedure DoDownDialog;  {Download dialog}
    procedure multipleup;  {Allows selection of multiple files}
    procedure writeshellmsg; virtual;  {Replace default shell to dos msg}
    procedure GetEvent(var Event: TEvent); virtual;
  end;

  plongint = ^longint;
  psymbolist = ^Tsymbolist;
  Tsymbolist = object(TObject)
    name: pstring;     {The collection has 2 fields per record, name is
    			the description of the symbol eg RANGE and recpos
                        is the ascii position}
    recpos: plongint;
    constructor Init(newname: string; newrecpos: longint);
    destructor Done; virtual;
  end;

  psymbolcollection = ^TprotCollection;
  TprotCollection = object(TsortedCollection)
  {sorts the above collection on the symbol name}
    function KeyOf(Item: Pointer): Pointer; virtual;
    function Compare(Key1, Key2: Pointer): Integer; virtual;
  end;

type pmysortedlistbox = ^Tmysortedlistbox;
     tmysortedlistbox = object(tsortedlistbox)
   {The list box of the symbols - get text is overridden so that the
   symbol names are shown. The handleevent is overriden so that the spaces
   are treated as search characters}
     procedure HandleEvent(var Event: TEvent); virtual;
     function GetText(Item: Integer; MaxLen: Integer): String; virtual;
end;

  PUpload  = ^Tupload;               {Upload a file}
  TUpload  = Object(TbxPercentDialog)
    Procedure   Process; Virtual;    {<--- All the work gets done here}
  end;

  PdownDialog  = ^TdownDialog;       {Downloads a file}
  TdownDialog  = Object(TbxPercentDialog)
    Procedure   Process; Virtual;    {<--- All the work gets done here}
  end;

  PUpMultipleDialog  = ^TUpMultipleDialog;  {Uploads multiple files}
  TUpMultipleDialog  = Object(TbxPercentDialog)
    Procedure   Process; Virtual;    {<--- All the work gets done here}
  end;

type configrec = record
     port, baud, parity, model: word; {Configuration files}
     delay: string[3];
end;

const
  HeapSize = 40 * (1024 div 16); {For editor}
  bloodydelay : word = 0;  {How much to delay every time a char is sent}
  maxtimeout  : word = 1500;
  {How long to wait before aborting with a timeout error.}

{Command constants}
  cmShowClip   		= 102;
  cmupedit     		= 103;
  cmupprog     		= 104;
  cmdownedit   		= 105;
  cmdownalledit 	= 106;
  cmabout      		= 107;
  cmsetup      		= 108;
  cmupmultipleedit 	= 110;
  cmreadnow        	= 111;
  cmprocessmultiple 	= 112;
  cmwindows         	= 113;
  cmconvert         	= 115;
  cminsertsymbol    	= 116;
  cfx9800           	= 0; {model number}
  cfx9850           	= 1; {model number}
  calctype: byte = cfx9800;  {Default model}

var
   comBuffer  : array[0..8192] of char;  {all I/O takes place here}
   prog : array[0..32000] of byte; 	 {32K for programme length}
   header: array[0..49] of byte;  	 {header array}
   casioapp: Tcasioapp;		  	 {pointer to main object}
   ClipWindow: PEditWindow;		 {poimter to clipboard object}
   edit: pwindow;			 {pointer to editor window}
   temp,				 {temporary use}
   comport: byte;		         {Current comport 1=Com1, 2=Com2..}
   bytechar: char;			 {temporary}
   result,				 {For messagebox}
   tempi, tempj,			 {Temporary}
   lengthof,				 {Holds length of programme}
   chksum: word;                         {Holds chksum of programme}
   retcode: integer;			 {For sioget/sioputc}
   specialDialog : PdownDialog;          {for multiple dialog}
   ok, allok, one: boolean;		 {Temporary}
   globals, fname: string;		 {Temporary}
   P: PathStr;				{----              }
   D: DirStr;                           {    |- For fsplit }
   N: NameStr;                          {    |             }
   E: ExtStr;                           {----              }
   tempp: pointer; 			{Temporary for "please wait"}
   tempcollection: pcollection;		{Temporary collection to hold
   					items}
   List2   : PbxCollection;             {Temporary}
   configvar: configrec;		{Configuration file}
   configfile: file of configrec;	{Configuration file}
   textfile: text;			{Temp}
   FileName: FNameStr;			{Temp}
   sendlist: psymbolcollection;	 	{holds list of sorted symbols}
   dchoosesymbox: pmysortedlistbox;     {The list box}
   menu: pmenu;                         {pointer to local menu}
   localmenuopen: boolean;              {is the local menu open??}

procedure tcasioapp.GetEvent(var Event: TEvent);
{Overriden to provide local menu support}
var code: word;
    newevent: tevent;
    box: pmenubox;
    r: trect;
    mp: tpoint;

begin
  inherited getevent(event);
  if ((event.what = evmousedown) and (event.buttons = mbrightbutton) and
  not localmenuopen) then
    begin
      localmenuopen:=true;               {It's open now}
      mp:=event.where;
      if (mp.x > 70) then mp.x:=70;
      if (mp.y > 20) then mp.y:=20;
      if (mp.x < 17) then mp.x:=17;
      if (mp.y < 5) then mp.y:=5;
      clearevent(event);
      r.assign (mp.x, mp.y, mp.x+11, mp.y+2);
      box:=new (pmenubox, init(r, menu, nil));
      code:=execview (box);
      dispose (box);
      localmenuopen:=false;
      newevent.what:=evcommand;
      newevent.command:=code;
      putevent(newevent);
    end;
end;

procedure delfixsym (var S: String);
{Used when this command cannot be used in an object}
begin
  delete (s, 2, 1);
  delete (s, length(s), 1);
end;

Function Tprotcollection.KeyOf(Item: Pointer): Pointer;
{Sort by the symbol name}
begin
  KeyOf := psymbolist(Item)^.name;
end;

destructor Tsymbolist.Done;
{Remove from heap}
begin
  disposestr (name);
  dispose (recpos);
end;

Function Tprotcollection.Compare(Key1, Key2: Pointer): Integer;
{For comparison in list box - uppercase and lowercase are treated equally}
begin
  if PString(Key1)^ = PString(Key2)^ then
    Compare := 0
  else if PString(Key1)^ < PString(Key2)^ then
    Compare := -1
  else
    Compare := 1;
end;

procedure TmySortedListBox.HandleEvent(var Event: TEvent);
{Same as the inherited one but treats space as a character}
var
  CurString, NewString: String;
  K: Pointer;
  Value, OldPos, OldValue: Integer;
  T: Boolean;

function Equal(const S1, S2: String; Count: Word): Boolean;
var
  I: Word;
begin
  Equal := False;
  if (Length(S1) < Count) or (Length(S2) < Count) then Exit;
  for I := 1 to Count do
    if UpCase(S1[I]) <> UpCase(S2[I]) then Exit;
  Equal := True;
end;

begin
  OldValue := Focused;
  TListBox.HandleEvent(Event);
  if OldValue <> Focused then SearchPos := 0;
  if Event.What = evKeyDown then
  begin
    if Event.CharCode <> #0 then
    begin
      Value := Focused;
      if Value < Range then CurString := GetText(Value, 255)
      else CurString := '';
      OldPos := SearchPos;
      if Event.KeyCode = kbBack then
      begin
        if SearchPos = 0 then Exit;
        Dec(SearchPos);
        if SearchPos = 0 then ShiftState := GetShiftState;
        CurString[0] := Char(SearchPos);
      end
      else if (Event.CharCode = '.') then SearchPos := Pos('.',CurString)
      else
      begin
        Inc(SearchPos);
        if SearchPos = 1 then ShiftState := GetShiftState;
        CurString[0] := Char(SearchPos);
        CurString[SearchPos] := upcase(Event.CharCode);
      end;
      K := GetKey(CurString);
      T := PSortedCollection(List)^.Search(K, Value);
      if Value < Range then
      begin
        if Value < Range then NewString := GetText(Value, 255)
        else NewString := '';
        if Equal(NewString, CurString, SearchPos) then
        begin
          if Value <> OldValue then
          begin
            FocusItem(Value);
            { Assumes ListControl will set the cursor to the first character }
            { of the sfFocused item }
            SetCursor(Cursor.X+SearchPos, Cursor.Y);
          end
          else SetCursor(Cursor.X+(SearchPos-OldPos), Cursor.Y);
        end
        else SearchPos := OldPos;
      end
      else SearchPos := OldPos;
      if (SearchPos <> OldPos) or (Event.CharCode in ['A'..'Z','a'..'z']) then
        ClearEvent(Event);
    end;
  end;
end;

function Makesymbolbox: PDialog;
{Shows the symbol box}
var
  Control, Crnt: PView;
  R: TRect;
  dlg: pdialog;
  SB1: PScrollBar;
begin
  R.Assign(13, 3, 45, 17);
  dlg := New(PDialog, Init(R, 'Symbols available'));
  with Dlg^ do begin
    Options := ofSelectable or ofTopSelect or ofBuffered or ofCenterX or ofCenterY or ofVersion20;
    R.Assign(25, 3, 26, 10);
    SB1 := New(PScrollBar, Init(R));
    Insert(SB1);
    R.Assign(3, 3, 25, 10);
    dchoosesymbox := New(PmySortedListBox, Init(R, 1, SB1));
    Insert(dchoosesymbox);
    dchoosesymbox^.select;
    R.Assign(2, 2, 17, 3);
    Insert(New(PLabel, Init(R, '~S~ymbols', Crnt)));
    R.Assign(2, 11, 12, 13);
    Control := New(PButton, Init(R, '~O~k', cmOk, bfDefault));
    Insert(Control);
    R.Assign(15, 11, 25, 13);
    Control := New(PButton, Init(R, '~C~ancel', cmcancel, bfNormal));
    Insert(Control);
  end;
  dchoosesymbox^.newlist (sendlist);
  dchoosesymbox^.select;
  Makesymbolbox:= PDialog(Dlg);
end;


Function Tmysortedlistbox.GetText(Item: Integer; MaxLen: Integer): String;
{Override so as to show the symbols are shown in the list box}
begin
   gettext:=(psymbolist(sendlist^.at(item))^.name)^;
end;

function searchsymbol(C: Psymbolcollection; strToFind: String) : longint;
{Check for a symbol in the collection}
function namematch(Client: psymbolist): Boolean; far;
begin
  namematch := (strtofind=Client^.name^) ;
end;

var
  FoundClient: Psymbolist;
begin
  FoundClient := C^.FirstThat(@nameMatch);
  if FoundClient = nil then
    searchsymbol:=-1
  else
      searchsymbol:=foundclient^.recpos^;
end;

function IntToStr(I: Longint): String;
{ Convert any integer type to a string }
var
 S: string[11];
begin
 Str(I, S);
 IntToStr := S;
end;

procedure deletefix (var S: String; Index: Integer; Count:Integer);
{for when in objects}
begin
  delete (s, index, count);
end;

procedure tcasioapp.writeshellmsg;
{Override, for custom message}
begin
  printstr ('Type Exit to return to Link-Up...'+#13+#10);
  printstr ('You are now SHELLED to Dos, do not load any TSR''s !')
end;

function deltemps (s: string): string;
{Chop off a random letter if it exists}
begin
 if length(s) > 7 then
 delete (s, random (7)+1, 1) else
 delete (s, random (length(s)-1)+1, 1);
 deltemps:=s;
end;

function handlestring (source: string; ival: byte): string;
{Translate special symbol to token}
begin
  if ival > 32 then ival:=ival+95; {In collection, ascii letters are not
                                   inserted so skip chunk}
  if ival > 152 then inc (ival); {if over 152 skip 1 position --> ???}
  handlestring:=chr(ival);
end;

procedure fillendheader;
{For cfx-9850 - makes the last header to indicate end of transfer}
begin
  fillchar (header, sizeof(header), 255);
  header[0]:=58;
  header[1]:=ord('E');
  header[2]:=ord('N');
  header[3]:=ord('D');
  header[49]:=86;
end;

function fileexists (fn: string): boolean;
{Returns true if the file fn exists}
var f: text;
begin
  assign (f, fn);
  {$I-}
  reset (f);
  fileexists:=ioresult=0;
  close (f);
  if ioresult = 0 then;
  {$I+}
end;

function upstr(s: string): string;
{Returns the uppercase of string s}
var i: byte;
begin
  for i := 1 to Length(s) do
    s[i] := UpCase(s[i]);
    upstr:=s;
end;

procedure closethefile;
{For use when in an object}
begin
    {$I-}
    close (textfile);
    if ioresult <> 0 then ;
end;

procedure TUpMultipleDialog.Process;
{Upload more than 1 file}
var result: word;
    s: string;
    timeout, i: word;
    event: tevent;
    f: text;
begin
    runstate:=cmstartjob;   {Start immediately}
    if (RunState > 0) and (RunState < cmCancelJob) then  {Has it started?}
    begin
      begin
	  sioputc (comport, chr(22));	{Send initial}
	   changemessage ('Waiting for reply...');
	   repeat
	     retcode:=siogetc (comport, 0); {Get a character}
	     delay (bloodydelay);
	     tupmultipledialog.handleevent (event);  {Button pressed?}
	     getevent (event);			     {Check for new event}
	     if event.what = evcommand then	     {Cancel if there is}
	      begin
		messagebox ('Transfer aborted', nil, mferror+mfokbutton);
		runstate:=cmjobcomplete;        {Say a cute message}
		exit;
	      end;
	    until (retcode <> -1);
	 if (retcode <> 19) and (calctype = cfx9800) then  {cfx-9850 doesn't
							report it??!!!}
	   begin
	     runstate:=cmjobcomplete;
	     messagebox ('Calculator reported a Checksum error ', nil, mferror+mfokbutton);
	     exit;
	    end;
   begin
     for i := 1 to List2^.Count do        {All those in the list of multiple
					  files}
     begin
       count:=0;
       disposestr (bar^.text);             {Clear the bar again}
       bar^.text:=newstr ('');  {Supposedly readonly!}
       bar^.drawview;  {Draw the new bar}
       disposestr (pct^.text);
       pct^.text:=newstr ('  0%');   {Update the percentage}
       pct^.drawview;

       changemessage ('Reading file');

       fillchar (header, sizeof(header), 255); {Reset stuff just in case}
       fillchar (prog, sizeof(prog), #0);      {Reset stuff just in case}
       S := PbxObject(List2^.At(i - 1))^.GetText(255);  {Get filename}
       globals:=s+'.LNK';
       message (application, evcommand, cmreadnow, nil); {Read that file}
       if calctype = cfx9800 then
         begin
            header[0]:=$3a; {:}               {Colon}
            header[1]:=70;  {F}               {Magic}
            header[2]:=78;  {N}               {Magic}
            header[3]:=0;
            header[4]:=trunc(int (lengthof/256));   {Low byte}
            header[5]:=lengthof mod 256+3;          {High byte}
            header[6]:=0;
            header[7]:=0;
            chksum:=0;
            for tempi:=8 to length(s)+7 do
              header[tempi]:=ord(s[tempi-7]);  {File name}

            {Get checksum}
            for tempi:=0 to 38 do chksum:=(chksum+header[tempi]) mod 256;
              header[39]:=(58-chksum) mod 256;
            IF header[39] < 0 THEN header[39]:= header[39] + 256;

            {Now verify checksum}
            CHKSUM:=0;
            for tempi:=0 to 39 do
            chksum:=(chksum + header[tempi]) mod 256;

            {This *should* never arise}
            IF CHksum <> 58 then
            begin
              messagebox ('Wrong Checksum. Please contact Wallace Wadge', nil, mferror+mfokbutton);
              exit;
            end;
            end else
            {For cfx-9850G}
            begin
              fillchar (prog, sizeof(prog), #0);  {Reset just in case}
              fillchar (header, sizeof(header), #255);
              chksum:=0;
              header[0]:=$3a;
              header[1]:=ord('T');           {Header of cfx-9850}
              header[2]:=ord('X');;
              header[3]:=ord ('T');
              header[4]:=0;
              header[5]:=ord('P');;
              header[6]:=ord('G');
              header[7]:=0;
              header[8]:=0;
              header[9]:=lengthof div 256;
              header[10]:=(lengthof mod 256)+2;
              for tempi:=11 to length(s)+10 do
                header[tempi]:=ord(s[tempi-10]);
              header[35]:=ord ('N');
              header[36]:=ord('L');
              for tempi:=0 to 48 do chksum:=(chksum+header[tempi]) mod 256;
              header[49]:=(58-chksum) mod 256;
            end;
            {$I-}
              closethefile;   {Close the damn file, can't close it here coz
	      			it thinks we're closing some object}
            if ioresult <> 0 then ; {Don't care about errors}
            {$I+}
     changemessage ('Sending header');
    if calctype <> cfx9800 then delay (120);  {Donno why but doesn't work
    						without}
    if calctype = cfx9800 then tempj:=39 else tempj:=49;
     delay (20);
     {send the header}
     for tempi:=0 to tempj do
     begin
         retcode:=sioputc (comport, chr(header[tempi])); {Send the header}
          delay (10);
	  tupmultipledialog.handleevent (event); {Enable button pressing}
	  getevent (event);                      {any new button press?}
         if event.what = evcommand then          {only cancel button can
                                                 generate a command here}
	      begin
	        messagebox ('Transfer aborted', nil, mferror+mfokbutton);
                runstate:=cmjobcomplete;
            	exit;
              end;

       end;
     total:=lengthof;
     delay (100);
     changemessage ('Header sent. Waiting for confirmation');
     begin
     repeat
       retcode:=siogetc (comport, 0);  {Get the ack}
       delay (bloodydelay);            {????}
       tupmultipledialog.handleevent (event);  {Simkulate button press}
       getevent (event);                       {Gets the event}
       if event.what = evcommand then
	begin
	 messagebox ('Transfer aborted', nil, mferror+mfokbutton);
	 runstate:=cmjobcomplete;
	 exit;
       end;
     until (retcode <> -1);
   if retcode = 36 then
     begin
       runstate:=cmjobcomplete;
       messagebox ('Not enough memory on receiving calculator', nil, mferror+mfokbutton);
       exit;
     end;
   end;
   if retcode = 43 then
   begin
      runstate:=cmjobcomplete;
      messagebox ('Checksum error. Please contact Wallace Wadge', nil, mferror+mfokbutton);
      exit;
   end;
   if (retcode = 33) then
     begin
       result:=messagebox ('Programme area already exists. Overwrite?', nil, mfconfirmation+
       mfyesbutton+mfnobutton);
       if result = cmyes then
	 begin
	   changemessage ('Informing calculator to overwrite. ');
	   sioputc (comport, chr($06));
	   delay (200);
	   changemessage ('Waiting for calculator to acknowledge');
           repeat
	     retcode:=siogetc (comport, 0);
	     tupmultipledialog.handleevent (event);
             getevent (event);
       if event.what = evcommand then
	begin
	 messagebox ('Transfer aborted', nil, mferror+mfokbutton);
	 runstate:=cmjobcomplete;
	 exit;
       end;
	until (retcode <> -1);
	if retcode = 6 then changemessage ('Confirmed..');
	siorxflush(comport);  {Just in case there's something pending}
	 end else
       begin
	  changemessage ('Aborting...');
	   runstate:=cmjobcomplete;
	   sioputc (comport, chr($15));  {Ok buzz off}
	   delay (20);
	   exit;
       end;
     end;
   delay (bloodydelay);
  if calctype = cfx9800 then
    tempj:=0 else
      begin
	tempj:=4;
	chksum:=0;
	if bloodydelay <> 0 then bloodydelay:=2;
	prog[lengthof]:=255;
  delay (200);
      end;
  chksum:=0;
  {Send the data}
  changemessage ('Sending '+s+'.LNK ('+inttostr (lengthof)+' bytes)');
  for tempi:=0 to lengthof+4-tempj do
     begin
       sioputc (comport, chr(prog[tempi])); {This commands does the main work}
       if tempi <> 0 then chksum:=chksum+ord(prog[tempi]); {For cfx-9850}
       delay (bloodydelay);
       increment;  {For percentage bar}
       tupmultipledialog.handleevent (event); {If he presses a button it
						is shown being pressed}
       getevent (event);	{Get the real event of what happened}
       if event.what = evcommand then {only abort commands are available here}
	      begin
		messagebox ('Transfer aborted', nil, mferror+mfokbutton);
		runstate:=cmjobcomplete;   {Quits the percentage dialog}
		exit;			   {Gerrout}
	      end;

    end;
 timeout:=0;				{Reset variable}
 if calctype = cfx9800 then
 begin
   changemessage ('Waiting...');
 repeat
   retcode:=siogetc (comport, 0);       {Get a character}
   delay (bloodydelay);
   {inc (timeout);
   }tupmultipledialog.handleevent (event);
   getevent (event);
   if event.what = evcommand then
	begin
	  messagebox ('Transfer aborted', nil, mferror+mfokbutton);
	  runstate:=cmjobcomplete;
	  exit;
	end;

 until {(timeout = maxtimeout) or} (retcode = 6);
 delay (200);
{ if timeout = maxtimeout then
 messagebox ('Calculator indicated an error. Please contact Wallace Wadge', nil, mferror+mfokbutton);
}end else
begin
  changemessage ('Sending checksum...');
  chksum:=abs(255-(chksum mod 256))+1;
  sioputc (comport, chr(chksum));  {Send the checksum for cfx-9850}
  timeout:=0;
  changemessage ('Waiting for acknoledgement...');
  repeat

    retcode:=siogetc (comport, 0);
    tupmultipledialog.handleevent (event);

    getevent (event);
    if event.what = evcommand then
	 begin
	   messagebox ('Transfer aborted', nil, mferror+mfokbutton);
	   runstate:=cmjobcomplete;
	   exit;
	 end;

  until (retcode = $6);
 delay (200);
end;
end;
    changemessage ('Ending transfer');
    RunState := cmJobComplete;
if calctype = cfx9800 then
begin
 header[0]:=ord(':');
 header[1]:=23;
 for i:=2 to 38 do header[i]:=255;
 header[39]:=14;
 end else
   begin
     fillendheader;
     delay (50);
   end;
 if calctype = cfx9800 then tempj:=39 else tempj:=49;
 for i:=0 to tempj do
   begin
     sioputc (comport, chr(header[i]));
     delay (bloodydelay {10});
     tupmultipledialog.handleevent (event);

     getevent (event);
     if event.what = evcommand then
	begin
	  messagebox ('Transfer aborted', nil, mferror+mfokbutton);
	  runstate:=cmjobcomplete;
	  exit;
	end;

   end;
   end;
   end;
   end;
end;

procedure parsefile;
{Translates from prog array to file including symbol conversion}
var lp: word;
    temps: string;
    result: word;
    temp: word;
begin
  lp:=0;
temps:='';

for lp:=0 to lengthof do
  if prog[lp] = 255 then
    begin
      temp:=lp;
      break;
    end;
  temps:='';
  for lp:=1 to temp-1 do
   begin
       case prog[lp] of
        1: TEMPS:=TEMPS+'$FEMTO$';
        2: TEMPS:=TEMPS+'$PICO$';
        3: TEMPS:=TEMPS+'$NANO$';
        4: TEMPS:=TEMPS+'$MICRO$';
        5: TEMPS:=TEMPS+'$MILLI$';
        6: TEMPS:=TEMPS+'$KILO$';
        7: TEMPS:=TEMPS+'$MEGA$';
        8: TEMPS:=TEMPS+'$GIGA$';
        9: TEMPS:=TEMPS+'$TERA$';
        10: TEMPS:=TEMPS+'$PETA$';
        11: TEMPS:=TEMPS+'$EXA$';
        12: TEMPS:=TEMPS+'$- DISP -$';
        13: TEMPS:=TEMPS+#13;
        14: TEMPS:=TEMPS+'$->$';
        15: TEMPS:=TEMPS+'$EXP$';
        16: TEMPS:=TEMPS+'$=<$';
        17: TEMPS:=TEMPS+'$<>$';
        18: TEMPS:=TEMPS+'$>=$';
        19: TEMPS:=TEMPS+'$=>$';
        20: TEMPS:=TEMPS+'$F1$';
        21: TEMPS:=TEMPS+'$F2$';
        22: TEMPS:=TEMPS+'$F3$';
        23: TEMPS:=TEMPS+'$F4$';
        24: TEMPS:=TEMPS+'$F5$';
        25: TEMPS:=TEMPS+'$F6$';
        26: TEMPS:=TEMPS+'$A$';
        27: TEMPS:=TEMPS+'$B$';
        28: TEMPS:=TEMPS+'$C$';
        29: TEMPS:=TEMPS+'$D$';
        30: TEMPS:=TEMPS+'$E$';
        31: TEMPS:=TEMPS+'$F$';
        127: TEMPS:=TEMPS+'$SIGMA$';
        128: TEMPS:=TEMPS+'$POL($';
        129: TEMPS:=TEMPS+'$SIN$';
        130: TEMPS:=TEMPS+'$COS$';
        131: TEMPS:=TEMPS+'$TAN$';
        132: TEMPS:=TEMPS+'$H (HEX)$';
        133: TEMPS:=TEMPS+'$LN$';
        134: TEMPS:=TEMPS+'$^0.5$';
        135: TEMPS:=TEMPS+'-';
        136: TEMPS:=TEMPS+'$P$';
        137: TEMPS:=TEMPS+'+';
        138: TEMPS:=TEMPS+'$XNOR$';
        139: TEMPS:=TEMPS+'$^2$';
        140: TEMPS:=TEMPS+'$$';
        141: TEMPS:=TEMPS+'$INTEGRAL($';
        142: TEMPS:=TEMPS+'$MOD$';
        143: TEMPS:=TEMPS+'$SIGMA X2$';
        144: TEMPS:=TEMPS+'$POL($';
        145: TEMPS:=TEMPS+'$SIN-1$';
        146: TEMPS:=TEMPS+'$COS-1$';
        147: TEMPS:=TEMPS+'$TAN-1$';
        148: TEMPS:=TEMPS+'$D (DEC)$';
        149: TEMPS:=TEMPS+'$LOG$';
        150: TEMPS:=TEMPS+'$^1/3$';
        151: TEMPS:=TEMPS+'$ABS$';
        153: TEMPS:=TEMPS+'-'{'$-$'};
        154: TEMPS:=TEMPS+'$XOR$';
        155: TEMPS:=TEMPS+'$^-1$';
        156: TEMPS:=TEMPS+'$DEGREES$';
        157: TEMPS:=TEMPS+'$INTEGRAL($';
        158: TEMPS:=TEMPS+'$MED$';
        159: TEMPS:=TEMPS+'$SIGMA X$';
        160: TEMPS:=TEMPS+'$REC($';
        161: TEMPS:=TEMPS+'$SINH$';
        162: TEMPS:=TEMPS+'$COSH$';
        163: TEMPS:=TEMPS+'$TANH$';
        164: TEMPS:=TEMPS+'$O (OCT)$';
        165: TEMPS:=TEMPS+'$E$';
        166: TEMPS:=TEMPS+'$INT$';
        167: TEMPS:=TEMPS+'$NOT$';
        168: TEMPS:=TEMPS+'$X^Y$';
        169: TEMPS:=TEMPS+'*';
        170: TEMPS:=TEMPS+'$OR$';
        171: TEMPS:=TEMPS+'!';
        172: TEMPS:=TEMPS+'$R (RADIANS)$';
        173: TEMPS:=TEMPS+'$INTEGRAL($';
        174: TEMPS:=TEMPS+'$MIN$';
        175: TEMPS:=TEMPS+'$N$';
        176: TEMPS:=TEMPS+'$REC($';
        177: TEMPS:=TEMPS+'$SINH-1$';
        178: TEMPS:=TEMPS+'$COSH-1$';
        179: TEMPS:=TEMPS+'$TANH-1$';
        180: TEMPS:=TEMPS+'$B (BIN)$';
        181: TEMPS:=TEMPS+'$10^$';
        182: TEMPS:=TEMPS+'$FRAC$';
        183: TEMPS:=TEMPS+'$NEG$';
        184: TEMPS:=TEMPS+'$^1/X$';
        185: TEMPS:=TEMPS+'$/$';
        186: TEMPS:=TEMPS+'$AND$';
        187: TEMPS:=TEMPS+'$_|$';
        188: TEMPS:=TEMPS+'$G (GRADIANS)$';
        189: TEMPS:=TEMPS+'$INTEGRAL($';
        190: TEMPS:=TEMPS+'$MAX$';
        191: TEMPS:=TEMPS+'$SIGMA Y2$';
        192: TEMPS:=TEMPS+'$ANS$';
        193: TEMPS:=TEMPS+'$RAN#$';
        194: TEMPS:=TEMPS+'$MEAN X$';
        195: TEMPS:=TEMPS+'$MEAN Y$';
        196: TEMPS:=TEMPS+'$XON$';
        197: TEMPS:=TEMPS+'$XON-1$';
        198: TEMPS:=TEMPS+'$YON$';
        199: TEMPS:=TEMPS+'$YON-1$';
        200: TEMPS:=TEMPS+'$LR A$';
        201: TEMPS:=TEMPS+'$LR B$';
        202: TEMPS:=TEMPS+'$LR R$';
        203: TEMPS:=TEMPS+'$PEAK X$';
        204: TEMPS:=TEMPS+'$PEAK Y$';
        205: TEMPS:=TEMPS+'$R$';
        206: TEMPS:=TEMPS+'$THETA$';
        207: TEMPS:=TEMPS+'$SIGMA Y$';
        208: TEMPS:=TEMPS+'$PI$';
        209: TEMPS:=TEMPS+'$CLS$';
        210: TEMPS:=TEMPS+'$MCL$';
        211: TEMPS:=TEMPS+'$RND$';
        212: TEMPS:=TEMPS+'$DEC$';
        213: TEMPS:=TEMPS+'$HEX$';
        214: TEMPS:=TEMPS+'$BIN$';
        215: TEMPS:=TEMPS+'$OCT$';
        216: TEMPS:=TEMPS+'$SCL$';
        217: TEMPS:=TEMPS+'$NORM$';
        218: TEMPS:=TEMPS+'$DEG$';
        219: TEMPS:=TEMPS+'$RND$';
        220: TEMPS:=TEMPS+'$GRA$';
        221: TEMPS:=TEMPS+'$ENG$';
        222: TEMPS:=TEMPS+'$INTG$';
        223: TEMPS:=TEMPS+'$SIGMA XY$';
        224: TEMPS:=TEMPS+'$PLOT$';
        225: TEMPS:=TEMPS+'$LINE$';
        226: TEMPS:=TEMPS+'$LBL$';
        227: TEMPS:=TEMPS+'$FIX$';
        228: TEMPS:=TEMPS+'$SCI$';
        229: TEMPS:=TEMPS+'$DEFM$';
        230: TEMPS:=TEMPS+'$CL$';
        231: TEMPS:=TEMPS+'$DT$';
        232: TEMPS:=TEMPS+'$DSZ$';
        233: TEMPS:=TEMPS+'$ISZ$';
        234: TEMPS:=TEMPS+'$FACTOR$';
        235: TEMPS:=TEMPS+'$RANGE$';
        236: TEMPS:=TEMPS+'$GOTO$';
        237: TEMPS:=TEMPS+'$PROG$';
        238: TEMPS:=TEmps+'$GRAPH Y=$';
        239: TEMPS:=TEMPS+'$GRAPH INTEGRAL$';
        240: TEMPS:=TEMPS+'$GRAPH Y>$';
        241: TEMPS:=TEMPS+'$GRAPH Y<$';
        242: TEMPS:=TEMPS+'$GRAPH Y>=$';
        243: TEMPS:=TEMPS+'$GRAPH Y <=$';
        244: TEMPS:=TEMPS+'$GRAPH R=$';
        245: TEMPS:=TEMPS+'$GRAPH (X, Y)=$';
        251: TEMPS:=TEMPS+'$P($';
        252: TEMPS:=TEMPS+'$Q($';
        253: TEMPS:=TEMPS+'$R($';
        254: TEMPS:=TEMPS+'$T($';
        255: TEMPS:=TEMPS+'$END$';
    32..127: temps:=temps+chr(prog[lp]);  {normal ASCII}
       end;
       if length(temps) > 77 then
         begin                                 {More than editor screen?}
           if (chr(prog[lp]) = #13) then
           delete (temps, length(temps)-1, 2);
           writeln (textfile, temps);
           temps:='';
         end;
       if (chr(prog[lp]) = #13) then
         begin
           delete (temps, length(temps), 1);
           if temps[length(temps)] =#10 then delete (temps, length(temps), 1);
           writeln (textfile,temps);    {Issue return}
           temps:='';
         end;
     end;
  if (temps <> '') and (temps <> #255) then writeln (textfile, temps);
  close (textfile);
end;

procedure tdowndialog.Process;
{Download work is done here}
var i, result, timeout: word;
    temps2, temps: string;
    chksum: integer;
    tempchar: char;
    tempcoll: pstringcollection;
    j: word;
    event: tevent;

begin
  {$I+}
  allok:=false;
  tempcoll:=new (pstringcollection, init (10, 10));  {Temporary}
  if (RunState > 0) and (RunState < cmCancelJob) then
    begin
      if (RunState <> cmPauseJob) then
      begin
        Delay(5);
        RetCode := SioGetc(comport,0);  {Get a character}
        if retcode = 22 then
          begin
    	    tdowndialog.handleevent (event);
	    getevent (event);
    	    if event.what = evcommand then
	      begin
	        messagebox ('Transfer aborted', nil, mferror+mfokbutton);
                  runstate:=cmjobcomplete;
                exit;
              end;
            delay (120);
            sioputc (comport, chr(19));  {Send ACK}
            delay (120);
            if one then {One file?}
              begin
                changemessage ('Receiving header...');
                if calctype = cfx9800 then tempj:=39 else tempj:=49;
                for i:=0 to tempj do
                  begin
                    retcode:=siogetc (comport, 0);
                    if retcode <> -1 then header[i]:=retcode;
    	    	    tdowndialog.handleevent (event);
		getevent (event);
    	    if event.what = evcommand then
	      begin
	        messagebox ('Transfer aborted', nil, mferror+mfokbutton);
                  runstate:=cmjobcomplete;
                exit;
              end;

                  end;
                CHKSUM:=0;
                begin
                  for i:=0 to tempj do chksum:=(chksum + header[i]) mod 256;
                  if calctype = cfx9800 then lengthof:=header[4]*256+header[5]
                    else lengthof:=(header[9]*256+header[10]);
                  delay (120);
                  if (chksum <> 58) and (calctype = cfx9800) then
                    begin
                      messagebox ('Checksum error. Please contact Wallace Wadge', nil, mferror+mfokbutton);
                      exit;
                    end else sioputc (comport, chr(6));
                  total:=lengthof;
                  changemessage ('Receiving file');
                  i:=0;
		  if calctype = cfx9850 then inc (maxtimeout, 1000);
                  for i:=0 to lengthof-1 do
                    begin
                      changemessage ('Receiving file ('+inttostr(i)+' of '+inttostr(lengthof-1)+' bytes)');
		      repeat
			retcode:=siogetc (comport, 0);
                        delay (bloodydelay);
			tdowndialog.handleevent (event);
			getevent (event);
			if event.what = evcommand then
	      begin
		messagebox ('Transfer aborted', nil, mferror+mfokbutton);
		runstate:=cmjobcomplete;
		exit;
	      end;
		      until (retcode <> -1);
		      prog[i]:=retcode;
		      increment;         {Increase percent bar}
		  end;
		delay (200);
		changemessage ('Sending acknoledgment...');
		sioputc (comport, chr(6));
	      end;
	      allok:=true;
	      runstate:=cmjobcomplete;
	      end else
	      begin    {Multiple files}
	      repeat
		fillchar (header, sizeof(header), 255);      {reset just in
                                                             case}
		fillchar (prog, sizeof(prog), 255);
		count:=0;
		total:=0;
		tempchar:=barfillchar;
		barfillchar:=barchar;
		disposestr (bar^.text);
		bar^.text:=newstr ('');
		bar^.drawview;
		disposestr (pct^.text);
		pct^.text:=newstr ('  0%');
		pct^.drawview;
		barfillchar:=tempchar;
		specialdialog^.drawview;
		changemessage ('Waiting for file information...');
		tdowndialog.handleevent (event);
		getevent (event);
		if event.what = evcommand then
	      begin
		messagebox ('Transfer aborted', nil, mferror+mfokbutton);
		runstate:=cmjobcomplete;
	        exit;
	      end;
                {The cfx-9850 has 10 more bytes in the header}
		if calctype = cfx9800 then tempj:=39 else tempj:=49;

		for i:=0 to tempj do
		  begin
		    timeout:=0;
		    repeat
		      retcode:=siogetc (comport, 0);  {Get the header}
		      delay (bloodydelay);
		      tdowndialog.handleevent (event); {Allow button press}
		      getevent (event);                {Check for event}
		      if event.what = evcommand then   {only cancel button
                                                       can generate a command
                                                       here}
			begin
			  messagebox ('Transfer aborted', nil, mferror+mfokbutton);
			  runstate:=cmjobcomplete;
			  exit;
		 	end;

		    until (retcode <> -1);
                    changemessage ('Receiving file information...');
		    if (i = 1) and (((calctype=cfx9800) and (retcode = 23)) or ((calctype=cfx9850) and
		    (retcode = ord('E')) )) then
		      begin
                        {Ack}
			if calctype = cfx9850 then sioputc (comport, chr($6));
                        {traverse all files received}
			for i:=0 to tempcoll^.count-1 do
			  begin
			    changemessage ('Parsing file '+inttostr (i+1)+' of '+inttostr (tempcoll^.count));
			    count:=i;
			    total:=tempcoll^.count-1;
			    increment;
			    disposestr (bar^.text);
			    bar^.text:=newstr ('       Please wait       ');
			    bar^.drawview;
			    disposestr (pct^.text);
			    pct^.text:=newstr ('');
			    pct^.drawview;
			    assign (textfile, pstring(tempcoll^.at(i))^);
			    reset (textfile);
			    j:=0;
			    fillchar (prog, sizeof(prog), 255);
			    while not eof(textfile) do
			      begin
				read (textfile, tempchar);
				prog[j]:=ord(tempchar);
				inc (j);
			      end;
			  closethefile;     {Thinks we're in object if we
                                            say close (textfile)};
			  erase (Textfile); {Erase temp file}
              assign (textfile, copy (pstring(tempcoll^.at(i))^, 1, pos ('.', pstring(tempcoll^.at(i))^)-1)+'.LNK');
                          rewrite (textfile);
                          lengthof:=j;
                          parsefile;        {Ok, now dump in actual file}
                        end;
                      messagebox ('Transfer complete', nil, mfinformation+mfokbutton);
                      runstate:=cmjobcomplete;
                      exit;                   {Buzz off}
                    end;
	      if retcode <> -1 then header[i]:=retcode;
            end;
           CHKSUM:=0; {Reset}
       for i:=0 to tempj do chksum:=(chksum + header[i]) mod 256;
       if calctype = cfx9800 then lengthof:=header[4]*256+header[5] else
       lengthof:=header[9]*256+header[10];
       delay (120);
       if (chksum <> 58) and (calctype = cfx9800) then
       begin
         messagebox ('Checksum error !', nil, mferror+mfokbutton);
         exit;
       end else sioputc (comport, chr(6)); {Send ack}
       total:=lengthof;
       delay (20);
       temps:='';
       if calctype = cfx9800 then
       begin
         for i:=8 to 19 do            {Filename + validation }
         if header[i] <> 255 then
         if upcase(chr(header[i])) in ['A'..'Z', '0'..'9', '-'] then
         temps:=temps+chr(header[i]);
       end else
       begin
         for i:=11 to 18 do if header[i] <> 255 then      {Password}
         if upcase(chr(header[i])) in ['A'..'Z', '0'..'9', '-'] then
           temps:=temps+chr(header[i]);
       end;
{Since the calc allows more than 8 chars as a file, this routine will
chop off a letter from the filename if it exists. Note that the 9850 only
allows up to 8 chars so this routine will always be skipped}
   if (length(temps) > 8) then temps:=copy(temps, 1, 8);
  while fileexists (Temps+'.TMP') do temps:=deltemps(temps);
  {File already exists?}
   assign (textfile, temps+'.TMP');
   rewrite (textfile);
   tempcoll^.insert (newstr (temps+'.TMP'));
   changemessage ('Receiving file '+temps +' ('+inttostr (total)+' bytes)');
   i:=0;
   for i:=0 to lengthof-1 do
    begin
       timeout:=0;
	  repeat
	    retcode:=siogetc (comport, 0);
	    if calctype = cfx9800 then delay (bloodydelay) else
	    if bloodydelay <> 0 then delay (bloodydelay+2);
	    tdowndialog.handleevent (event);
	    getevent (event);
	    if event.what = evcommand then
	      begin
		messagebox ('Transfer aborted', nil, mferror+mfokbutton);
		runstate:=cmjobcomplete;
		exit;
	      end;

	  until (retcode <> -1);
	  if retcode <> -1 then
	  begin
	    write (textfile, chr(retcode));
	    increment;
	  end
         end;
    delay (200);
    sioputc (comport, chr(6));  {Send ack}
    closethefile;
until runstate=cmjobcomplete;
    end;
    runstate:=cmjobcomplete;     {Exit now}
   end;
    dispose (tempcoll, done);    {Free memory}
    end;
  end;
end;

Procedure tcasioapp.multipleup;    {Multiple file upload}
var dialog: pupmultipledialog;
begin
  New(dialog, Init('', 'Waiting for calculator', 1000, mfCancelbutton or mfMessageLine));
  ExecuteDialog(dialog, nil);
end;

Procedure Tcasioapp.DoDownDialog;  {Download}
var dialog: pdowndialog;
begin
  New(dialog, Init('', 'Waiting for calculator', 1000, mfCancelbutton or mfMessageLine));
  ExecuteDialog(dialog, nil);
end;

procedure tupload.process;     {Upload a file - main work}
var result: word;
    timeout: word;
    D: DirStr;
    N: NameStr;
    E: ExtStr;
    event: tevent;
begin
  runstate:=cmstartjob;
  if (RunState > 0) and (RunState < cmCancelJob) then
    begin
      if (RunState <> cmPauseJob) then
      begin
          sioputc (comport, chr(22));   {Are you ready dude?}
	   timeout:=0;
           repeat
             retcode:=siogetc (comport, 0);     {"YES"}
             delay (bloodydelay);
	   tupload.handleevent (event);  {Button pressed?}
	   getevent (event);             {Get event}
	   if event.what = evcommand then {Cancel button pressed?}
	      begin
		messagebox ('Transfer aborted', nil, mferror+mfokbutton);
		runstate:=cmjobcomplete;
		exit;
	      end;

	   until (retcode <> -1);
	 if calctype <> cfx9800 then delay (20);
	 if (retcode <> 19) and (calctype = cfx9800) then
	   begin
	     runstate:=cmjobcomplete;
             messagebox ('Calculator reported checksum error', nil, mferror+mfokbutton);
             exit;
            end;
   begin
     changemessage ('Sending header');
     if calctype = cfx9800 then tempj:=39 else tempj:=49;
     for tempi:=0 to tempj do
     begin
         retcode:=sioputc (comport, chr(header[tempi]));  {Send header}
         delay (10);
	 tupload.handleevent (event);  {Button pressed?}
	 getevent (event);             {Get button}
         if event.what = evcommand then
	      begin
	        messagebox ('Transfer aborted', nil, mferror+mfokbutton);
                runstate:=cmjobcomplete;
            	exit;
              end;

       end;
     changemessage ('Checksum sent. Waiting for confirmation');
     repeat
         retcode:=siogetc (comport,0);          {Get character}
    tupload.handleevent (event);  {Button pressed?}
	 getevent (event);             {Get button}
         if event.what = evcommand then
	      begin
	        messagebox ('Transfer aborted', nil, mferror+mfokbutton);
                runstate:=cmjobcomplete;
            	exit;
              end;
     until retcode <> -1;
   if retcode = 36 then
     begin
       runstate:=cmjobcomplete;
       messagebox ('Not enough memory on receiving calculator', nil, mferror+mfokbutton);
       exit;
     end;
   if retcode = 43 then
   begin
      runstate:=cmjobcomplete;
      messagebox ('Checksum error. Please contact Wallace Wadge', nil, mferror+mfokbutton);
      exit;
   end else
   if retcode = 33 then
     begin
       result:=messagebox ('Programme area already exists. Overwrite?', nil, mfconfirmation+
       mfyesbutton+mfnobutton);
       if result = cmyes then
         begin
           changemessage ('Informing calculator to overwrite');
           sioputc (comport, chr($06));   {Yeah dude, overrite}
           delay (200);
         end else
       begin
           runstate:=cmjobcomplete;
           sioputc (comport, chr($15));    {No so buzz off}
           delay (20);
           exit;
       end;
     end;
   delay (bloodydelay);
   fsplit (filename, d, n ,e);
  changemessage ('Sending '+n+e+' ('+inttostr (lengthof)+' bytes)');
  siotxflush(comport);        {Just in case}
  siorxflush(comport);

  if calctype = cfx9800 then
    tempj:=0 else
      begin
        tempj:=4;
        chksum:=0;
        if bloodydelay <> 0 then inc (bloodydelay, 5);
        prog[lengthof]:=255;
      end;
  for tempi:=0 to lengthof+4-tempj do
     begin
      retcode:=sioputc (comport, chr(prog[tempi]));    {Send the programme}
      tupload.handleevent (event);  {Button pressed?}
      getevent (event);             {Get event}
      if event.what = evcommand then  {Cancel button pressed?}
	begin
	  messagebox ('Transfer aborted', nil, mferror+mfokbutton);
          runstate:=cmjobcomplete;
          exit;
        end;
      changemessage ('Sending '+n+e+' ('+inttostr (lengthof)+' bytes)');
       if retcode = 0 then
         begin
           retcode:=siogetc (comport, 0);
           if (retcode <> -1) and (retcode <> 0) then
             messagebox (inttostr (retcode), nil, mfokbutton);
         end;
       if tempi <> 0 then chksum:=chksum+ord(prog[tempi]);
       delay (bloodydelay);
       increment;  {increase percentage bar}
    end;
  if calctype <> cfx9800 then
    begin
  chksum:=abs(255-(chksum mod 256))+1;
   sioputc (comport, chr(chksum));
      delay (500);
      fillendheader;
      for tempi:=0 to 49 do
        begin
          sioputc (comport, chr(header[tempi]));
          delay (10);
	 tupload.handleevent (event);  {Button pressed?}

	 getevent (event);
         if event.what = evcommand then
	      begin
	        messagebox ('Transfer aborted', nil, mferror+mfokbutton);
                runstate:=cmjobcomplete;
            	exit;
              end;

        end;
      prog[lengthof]:=255;
      chksum:=0;
    end;

    changemessage ('Ending transfer');
    delay (500);
    RunState := cmJobComplete;  {Clear dialog box}
    end;
   end;
      end;
end;

Procedure Tcasioapp.UploadDialog (editor: boolean); {Construct upload dialog
                                                    box}
var
    Dialog : Pupload;

begin
    messagebox ('Set the calculator in receive mode then press OK', nil, mfinformation+mfokbutton);
    New(Dialog, Init('', 'Sending file information...', lengthof, mfcancelbutton+mfMessageLine));
    ExecuteDialog(Dialog, nil);
end;

function OpenEditor(FileName: FNameStr; Visible: Boolean): PEditWindow;
var
  R: TRect;
  max: tpoint;
begin
  DeskTop^.GetExtent(R);
   Max.X := 80;
   Max.Y := 25;
   edit:=new(peditwindow, init (r, filename, 0));
   desktop^.insert (edit);
   if not Visible then edit^.Hide;
   OpenEditor:=peditwindow(edit);
end;

Function Windowscheck: boolean;
{Returns true if running under windows}
const
  Multplx_intr = $2F;  {Windows hooks to this}
var
  Regs : registers;
begin
  With Regs do
  begin
    AX := $1600;
    Intr(Multplx_intr,regs);                { $00 no Win 2.x or 3.x      }
    if AL in [$00,$01,$80,$FF] then         { $01 Win/386 2.x running    }
      Windowscheck := false                 { $80 obsolete XMS installed }
    else                                    { $FF Win/386 2.x running    }
      windowscheck := true;
   end;
end;

procedure initport;
{Prepares com port}
var temp: integer;
begin
  comport:=configvar.port;
  SioRxBuf(comPort, Ofs(comBuffer), Seg(comBuffer), Size8192); {Prepare
                                                    receive buffer}

    case configvar.baud of  {always try twice}
      0:
        begin
          sioreset (comport, baud1200);
          sioreset (comport, baud2400);
        end;
      1:
        begin
          sioreset (comport, baud2400);
          sioreset (comport, baud2400);
        end;
      2:
        begin
          sioreset (comport, baud4800);
          sioreset (comport, baud4800);
        end;
      3: begin
           sioreset (comport, baud9600);
           sioreset (comport, baud9600);
         end;
    end;

    SioRxFlush(comport);        {Flush any garbage}
    case configvar.parity of
      0: SioParms (comport, evenparity, twostopbits, wordlength8);
      1: SioParms(comport, oddparity, twostopbits, wordlength8);
      2: SioParms(comport, noparity, twostopbits, wordlength8);
    end;
    calctype:=configvar.model;
    siodtr (comport, 's');         {raise DTR}
    val(configvar.delay, bloodydelay, temp);
end;

procedure Tcasioapp.HandleEvent(var Event: TEvent);
{Main event parser}
type
  TpasswordData = record
    name: String[12];           {Password details}
    password: String[12];
  end;
var
   passvar: tpassworddata;

function Makepassword: PDialog;
{Constructs the password and name box}
var
  Control, Crnt: PView;
  R: TRect;
  Dlg: PDialog;
  V: PValidator;
begin
  R.Assign(19, 7, 60, 16);
  Dlg := New(PDialog, Init(R, 'Details'));
  with Dlg^ do begin
    Options := ofSelectable or ofTopSelect or ofBuffered or ofCenterX or ofCenterY or ofVersion20;
    R.Assign(18, 2, 32, 3);

    Crnt := New(PInputLine, Init(R, 12));

    Insert(Crnt);
    V := New(PFilterValidator, Init(['0'..'9','A'..'Z', 'a'..'z']));
    PInputLine(Crnt)^.SetValidator(V);
    R.Assign(11, 2, 16, 3);
    Insert(New(PLabel, Init(R, '~N~ame', Crnt)));
    R.Assign(32, 2, 35, 3);
    Insert(New(PHistory, Init(R, PInputLine(Crnt), 1)));
    R.Assign(18, 3, 32, 4);
    Control := New(PInputLine, Init(R, 12));
    Insert(Control);
    V := New(PFilterValidator, Init(['0'..'9','A'..'Z', 'a'..'z']));
    PInputLine(Control)^.SetValidator(V);
    R.Assign(7, 3, 16, 4);
    Insert(New(PLabel, Init(R, '~P~assword', Control)));
    R.Assign(32, 3, 35, 4);
    Insert(New(PHistory, Init(R, PInputLine(Control), 2)));
    R.Assign(3, 6, 13, 8);
    Control := New(PButton, Init(R, '~O~k', cmOk, bfDefault or bfGrabFocus));
    Insert(Control);
    R.Assign(16, 6, 26, 8);
    Control := New(PButton, Init(R, '~C~ancel', cmCancel, bfNormal));
    Insert(Control);
    Crnt^.Select;
  end;
  Makepassword := PDialog(Dlg);
end;

procedure FileOpen;
{Opens a file}
begin
  FileName := '*.lnk';
  if ExecuteDialog(New(PFileDialog, Init('*.*', 'Open file',
    '~N~ame', fdOpenButton, 100)), @FileName) <> cmCancel then
  begin
    calcenable:=false;
    OpenEditor(FileName, True);
    calcenable:=true;
  end;
end;

procedure FileNew;
{Opens an "untitled" file}
begin
  OpenEditor('', True);
end;

procedure ChangeDir;
{Change directory}
begin
  ExecuteDialog(New(PChDirDialog, Init(cdNormal, 0)), nil);
end;

procedure ShowClip;
{Show clipboard}
begin
  ClipWindow^.Select;
  ClipWindow^.Show;
end;

function MakeDialog: PDialog;
{Constructs the "about" dialog box}
var
  Control, Crnt: PView;
  R: TRect;
  Dlg: PDialog;
begin
  R.Assign(24, 4, 56, 18);
  Dlg := New(PDialog, Init(R, 'About'));
  with Dlg^ do begin
    Options := ofSelectable or ofTopSelect or ofBuffered or ofCenterX or ofCenterY or ofVersion20;
    R.Assign(12, 2, 19, 3);
    Crnt := New(PcolorStaticText, Init(R, '@X74LINK-UP'));
    Crnt^.Options := ofCenterX;
    Insert(Crnt);
    R.Assign(7, 8, 23, 9);
    Control := New(PcolorStaticText, Init(R, '@X71By Wallace Wadge'));
    Control^.Options := ofCenterX;
    Insert(Control);
    R.Assign(4, 6, 22, 7);
    Control := New(PStaticText, Init(R, 'Copyright (c) 1996'));
    Control^.Options := ofCenterX;
    Insert(Control);
    R.Assign(11, 11, 21, 13);
    Control := New(PButton, Init(R, '~O~k', cmOk, bfDefault));
    Control^.Options := ofSelectable or ofFirstClick or ofPreProcess or ofPostProcess or ofCenterX;
    Insert(Control);
    R.Assign(8, 4, 22, 5);
    Control := New(PStaticText, Init(R, 'Version 0.0041'));
    Control^.Options := ofCenterX;
    Insert(Control);
    Crnt^.Select;
  end;
  MakeDialog := PDialog(Dlg);
end;

function Makewait: PDialog;
{Says "please wait"}
var
  Control, Crnt: PView;
  R: TRect;
  Dlg: PDialog;
begin
  R.Assign(10, 5, 43, 12);
  Dlg := New(PDialog, Init(R, 'Please wait'));
  with Dlg^ do begin
    Flags := 0;
    Options := ofSelectable or ofTopSelect or ofBuffered or ofCenterX or ofCenterY or ofVersion20;
    R.Assign(4, 2, 28, 3);
    Control := New(PStaticText, Init(R, 'Loading and parsing file'));
    Control^.Options := ofCenterX;
    Insert(Control);
    R.Assign(10, 4, 21, 5);
    Crnt := New(PStaticText, Init(R, 'Please wait'));
    Crnt^.Options := ofCenterX;
    Insert(Crnt);
    Crnt^.Select;
  end;
  Makewait:= PDialog(Dlg);
end;

function MakeSetup: PDialog;
{constructs the setup dialog}
var
  Control, Crnt: PView;
  R: TRect;
  Dlg: PDialog;
  v: pvalidator;
begin
  R.Assign(10, 5, 64, 16);
  Dlg := New(PDialog, Init(R, 'Setup'));
  with Dlg^ do begin
    R.Assign(11, 2, 51, 3);
    Control := New(PRadioButtons, Init(R,
      NewSItem('COM1',
      NewSItem('COM2',
      NewSItem('COM3',
      NewSItem('COM4',
      nil))))
    ));
    Insert(Control);
    R.Assign(4, 2, 9, 3);
    Insert(New(PLabel, Init(R, 'Po~r~t', Control)));
    R.Assign(11, 3, 51, 4);
    Control := New(PRadioButtons, Init(R,
      NewSItem('~1~200',
      NewSItem('~2~400',
      NewSItem('~4~800',
      NewSItem('~9~600',
      nil))))
    ));
    Insert(Control);
    R.Assign(4, 3, 9, 4);
    Insert(New(PLabel, Init(R, '~B~aud', Control)));
    R.Assign(11, 4, 51, 5);
    Control := New(PRadioButtons, Init(R,
      NewSItem('~E~ven',
      NewSItem('O~d~d',
      NewSItem('~N~one',
      nil)))
    ));
    Insert(Control);
    R.Assign(2, 4, 9, 5);
    Insert(New(PLabel, Init(R, '~P~arity', Control)));
    R.Assign(11, 5, 51, 6);
    Control := New(PRadioButtons, Init(R,
      NewSItem('FX-9700/CFX-9800G',
      NewSItem('CFX-9850G',
      nil))
    ));
    Insert(Control);
    R.Assign(3, 5, 9, 6);
    Insert(New(PLabel, Init(R, '~M~odel', Control)));
    R.Assign(11, 6, 16, 7);
    Crnt := New(PInputLine, Init(R, 3));
    Insert(Crnt);
    V := New(PFilterValidator, Init(['0'..'9']));
    PInputLine(Crnt)^.SetValidator(V);
    R.Assign(2, 6, 9, 7);
    Insert(New(PLabel, Init(R, '~D~elay', Crnt)));


    R.Assign(3, 8, 13, 10);
    Crnt := New(PButton, Init(R, '~O~k', cmOk, bfDefault or bfGrabFocus));
    Insert(Crnt);
    R.Assign(16, 8, 26, 10);
    Control := New(PButton, Init(R, '~C~ancel', cmCancel, bfNormal));
    Insert(Control);
    Crnt^.Select;
  end;
  MakeSetup := PDialog(Dlg);
end;


function readstuff(editor: boolean; fname:string): boolean;
{if editor = true then ask for name/password}
var formatfile: text;
    colon: boolean;
    temps, temps2, p: string;
    tempi: longint;
    tempj: longint;
begin
  if ioresult <> 0 then ;  {Clear any pending error}
  if fname = '' then filename:=#8;  {Temp}
  readstuff:=true;
  if (desktop^.current = nil) and (fname='') then  {If no editor file is open}
    begin
      message (application, evcommand, cmopen, nil); {Call dialog}
      if filename = '*.lnk' then  {If he said cancel}
      begin
        readstuff:=false;
        exit;
      end else fname:= filename;
    end;
    if peditwindow(desktop^.current)^.gettitle(80) = 'Clipboard' then
    {If it's the clipboard abort}
    begin
      messagebox ('Cannot upload clipboard. ', nil, mferror+mfokbutton);
      readstuff:=false;
      exit;
    end;
  if filename = #8 then
  result:=messagebox ('Do you want to upload the currently open file ?', nil,
  mfconfirmation+mfyesbutton+mfnobutton) else result:=cmyes;
  if result = cmcancel then
    begin
      readstuff:=false;
      exit;
    end;
  if result = cmno then
    begin
      message (application, evcommand, cmopen, @p); {call dialog}
      if filename = '*.lnk' then
      begin
        readstuff:=false;
        exit;
      end else fname:=filename;
    end;
  message (application, evcommand, cmsave, nil);  {save the file before}
  if fname = '' then fname:=peditwindow(desktop^.current)^.gettitle(80);
  {Get the title}
  assign (formatfile, fname);
  reset (formatfile);
    FSplit(fname, D, N, E);
    if editor then       {If it's the editor ask for a name/password}
    begin
      passvar.name:=n;
      passvar.password:='';
      result:=executedialog (makepassword, @passvar);
      if result = cmcancel then
        begin
          readstuff:=false;
          exit;
        end;
    end;
    fillchar (prog, sizeof(prog), #0);    {Flush previous stuff}
    siotxflush (comport);         {Flush buffer for pending characters}
    tempp:=makewait;
    if editor then desktop^.insert (pdialog(tempp));  {Say "please wait"}
    tempi:=0;
    tempj:=0;
    ok:=false;
   colon:=false;
   tempj:=0;
  while not eof(formatfile) do
     begin
       readln (formatfile, temps);  {Read a string}
       if colon= false then
         begin
           temps:=':'+temps;        {If he forgot colon insert it}
           colon:=true;
         end;
         temps2:='';

       while pos ('$', temps) > 0 do  {Any tokens here?}
       begin
         temps2:=copy(temps, 1, pos('$', temps)-1);    {Get the word}
         deleteFix (temps, 1, pos('$', temps));   {Call external coz we're in
                                                  an object}
         p:=copy (temps, 1, pos ('$', temps)-1);

         deleteFix (temps, 1, pos('$', temps));
         if p = '/' then p:='$/$';  {very special case}
         tempi:=searchsymbol(sendlist, upstr(p));  {Make a comparison with
                                        fast binary search}

              if tempi <> -1 then   {Found?}
              begin
                 temps2:=temps2+handlestring (p, tempi);  {Ok then translate}
                 temps:=temps2+temps;
               end;
            end;

         {Handle these 4 special symbols}
       while pos ('-', temps) > 0 do temps[pos('-', temps)]:=chr(153);
       while pos ('+', temps) > 0 do temps[pos('+', temps)]:=chr(137);
       while pos ('*', temps) > 0 do temps[pos('*', temps)]:=chr(169);
       while pos ('!', temps) > 0 do temps[pos('!', temps)]:=chr(171);

         if (temps <> '') and (tempj > sizeof(prog)) then
           begin
             messagebox ('No memory space to store programme', nil, mferror+mfokbutton);
             exit;
           end;
         {Put in array - char by char}
         for tempi:=1 to length(temps) do
          begin
            prog[tempj]:=ord(temps[tempi]);
            inc (tempj);
          end;
          {Chr 12 is - Disp - coz calc displays an error if there's a
          carriage return after it. Disp automatically issues a carriage
          return}
          {77 below is the size of the editor. After that char no, a lf is
          issued to keep on typing. Thus if the lf found at position
          77 ignore it.}
          if (length(temps) <> 77) and (temps[length(temps)] <> chr(12)) then
            begin
              prog[tempj]:=13; {else insert for lf}
              inc (tempj);
            end;
     end;
     close (formatfile);
   if prog[0] = 255 then
     begin
       prog[0]:=58;  {0 length file - put dummy or will fail}
       inc (tempj);
     end;
   inc (tempj);
   prog[tempj]:=255;
   lengthof:=tempj;
   if editor then desktop^.delete (pdialog(tempp));  {Delete "please wait"
                                  dialog}
   fillchar (header, sizeof(header), #255);  {Clear stuff}
   filename:=fname;
end;

var s: string;
    tempb: byte;
    temps: string;

Procedure upmultiple;
{constructs the list box where clicking on one side transfers it to another
part}
  var
    Dialog  : PDialog;
    ListBox : PbxPairedListBox;
    List1   : PbxCollection;
    Bar     : PScrollBar;
    R       : TRect;
    i       : Word;
    S       : String;
var
 DirInfo: SearchRec;

  begin
    { paired list boxes move items from one box to the other }
    R.Assign(19,5,61,21);
    Dialog := New(PDialog, Init(R, 'Choose the files to upload'));

    R.Assign(19,3,20,12);
    Bar := New(PScrollBar, Init(R));
    Dialog^.Insert(Bar);
    R.Assign (2,3,19,12);
    ListBox := New(PbxPairedListBox, Init(R, 1, Bar));
    Dialog^.Insert(ListBox);
    R.Assign(2, 2, 18, 3);
    dialog^.Insert(New(PLabel, Init(R, '~A~vailable files', listbox)));

    List1 := New(PbxCollection, Init(15, 5));
    FindFirst('*.lnk', Anyfile, DirInfo);
while DosError = 0 do
begin
  List1^.Insert(New(PbxSelectStr, Init(copy (dirinfo.name,1, pos('.', dirinfo.name)-1))));
  FindNext(DirInfo);
end;
    ListBox^.NewList(List1);
    R.Assign(39,3,40,12);
    Bar := New(PScrollBar, Init(R));
    Dialog^.Insert(Bar);
    R.Assign(22,3,39,12);
    ListBox := New(PbxPairedListBox, Init(R, 1, Bar));
    Dialog^.Insert(ListBox);
     R.Assign(22, 2, 38, 3);
    dialog^.Insert(New(PLabel, Init(R, '~F~iles to upload', listbox)));

    List2 := New(PbxCollection, Init(15,5));
    ListBox^.NewList(List2);

    R.Assign(5,13,15,15);
    Dialog^.Insert(New(PButton, Init(R, '~O~K', cmOK, bfDefault)));
    R.Assign(20,13,30,15);
    Dialog^.Insert(New(PButton, Init(R, '~C~ancel', cmcancel, 0)));
    Dialog^.SelectNext (False);
    if ExecuteDialog(Dialog, nil) <> cmCancel then
    begin
    message (application, evcommand, cmprocessmultiple, nil);
    Dispose(List1, Done);
    Dispose(List2, Done);
      end;
  end;

var regs: registers;
    i: word;
    j: byte;

procedure searchandreplace (search, replace: string; params: word);
{Issues a search and replace}
begin
  message (edit, evkeydown, kbctrlpgup, nil); {Go on top of the document}
  FindStr := search;
  ReplaceStr := replace;
  EditorFlags := params;
  message (edit, evcommand, cmsearchagain, nil);
end;

begin
  inherited HandleEvent(Event);
  case Event.What of
    evCommand:
      case Event.Command of
        cmOpen: FileOpen;
        cmNew: FileNew;
        cmChangeDir: ChangeDir;
        cmShowClip: ShowClip;
        cmsetup:
          begin
            result:=executedialog (makesetup, @configvar);
            calctype:=configvar.model;
            if configvar.model = cfx9850 then disablecommands([cmupprog]) else
            enablecommands ([cmupprog]);
            regs.ax:=$0024;             {Check}
            intr ($33, regs);           {Mouse interrupt}
            if regs.bx <> $ffff then
              begin
                if (regs.cl = 4) and (configvar.port = 0) then
                  messagebox ('Link-Up has detected a mouse on that comport (IRQ 4). You should choose another port.', nil,
                  mfokbutton)
                  else
              if (regs.cl = 3) and (configvar.port = 1) then
                  messagebox ('Link-Up has detected a mouse on that comport (IRQ 3). You should choose another port', nil,
                  mfwarning+mfokbutton)
              end;
            if configvar.baud <> 3 then
          messagebox ('Although everything will still work, you should choose a baud rate of 9600 for the fastest transfers.',
            nil, mfinformation+mfokbutton);
            if result = cmok then
              begin
                if configvar.model = 1 then
              begin
                messagebox ('The CFX-9850G has fixed baud and parity settings so they will be ignored', nil, mfinformation+
                mfokbutton);
                configvar.baud:=3;
                configvar.parity:=2;
              end;
                initport;
                reset (configfile);
                write (configfile, configvar);

              end;
          end;
        cmupedit: {Upload}
        begin
          case configvar.parity of      {2 stop bits here}
      0: SioParms (comport, evenparity, twostopbits, wordlength8);
      1: SioParms(comport, oddparity, twostopbits, wordlength8);
      2: SioParms(comport, noparity, twostopbits, wordlength8);
    end;
          fillchar (prog, sizeof(prog), #0);
           fillchar (header, sizeof(header), 0);
            if readstuff(true, '') = false then
              begin
                exit;
              end;
              if calctype =cfx9800 then
            begin
              passvar.name:=upstr(passvar.name);
              passvar.password:=upstr(passvar.password);
            end else
            begin
              passvar.name:=upstr(copy(passvar.name,1 , 8));
               passvar.password:=upstr(copy(passvar.password, 1, 8));
            end;
            if calctype = cfx9800 then
            begin
            header[0]:=$3a;
            header[1]:=69;      {fill header}
            if passvar.password = '' then header[2]:=78 else header[2]:=80;
            header[3]:=0;
            header[4]:=trunc(int (lengthof/256));
            header[5]:=lengthof mod 256+3;
            header[6]:=0;
            header[7]:=0;
            for tempi:=8 to length(passvar.name)+7 do
              header[tempi]:=ord(passvar.name[tempi-7]);
            if passvar.password <> '' then
            begin
              for tempi:=20 to length(passvar.password)+19 do
               header[tempi]:=ord(passvar.password[tempi-19]);
            end;
            chksum:=0;
            for tempi:=0 to 38 do chksum:=(chksum+header[tempi]) mod 256;
            header[39]:=(58-chksum) mod 256;
            IF header[39] < 0 THEN header[39]:= header[39] + 256;
            CHKSUM:=0;
            for tempi:=0 to 39 do
            chksum:=(chksum + header[tempi]) mod 256;
            IF CHksum <> 58 then
            begin
              messagebox ('Wrong Checksum. Please contact Wallace Wadge', nil, mferror+mfokbutton);
              exit;
            end;
            end else
            begin
              header[0]:=$3a;
              header[1]:=ord('T');
              header[2]:=ord('X');;
              header[3]:=ord ('T');          {fill header}
              header[4]:=0;
              header[5]:=ord('P');;
              header[6]:=ord('G');
              header[7]:=0;
              header[8]:=0;
              header[9]:=lengthof div 256;
              header[10]:=(lengthof mod 256)+2;
              if passvar.name <> '' then
              begin
              for tempi:=11 to length(passvar.name)+10 do
                header[tempi]:=ord(passvar.name[tempi-10]);
              end;
              if passvar.password <> '' then
            begin
              for tempi:=29 to length(passvar.password)+28 do
               header[tempi]:=ord(passvar.password[tempi-28]);
            end;
             header[35]:=ord ('N');
              header[36]:=ord('L');
              chksum:=0;
              for tempi:=0 to 48 do chksum:=(chksum+header[tempi]) mod 256;
              header[49]:=(58-chksum) mod 256;
            end;
              UploadDialog (true);
              siorxflush (comport);
          end;
     cmupprog:  {Upload a programme}
           begin
             fillchar (header, sizeof(header), #0);
             fillchar (prog, sizeof(prog), #0);
		chksum:=0;
            case configvar.parity of
      0: SioParms (comport, evenparity, twostopbits, wordlength8);
      1: SioParms(comport, oddparity, twostopbits, wordlength8);
      2: SioParms(comport, noparity, twostopbits, wordlength8);
    end;
            if readstuff(false, '') = false then exit;
            header[0]:=$3a;
            header[1]:=$50;
            header[2]:=49;
            header[3]:=0;
            header[4]:=trunc(int (lengthof/256));
            header[5]:=lengthof mod 256+3;
            header[6]:=0;
            header[7]:=0;
            for tempi:=8 to 38 do header[tempi]:=255;
            for tempi:=0 to 38 do chksum:=(chksum+header[tempi]) mod 256;
   header[39]:=(58-chksum) mod 256;
   IF header[39] < 0 THEN header[39]:= header[39] + 256;
            CHKSUM:=0;
            for tempi:=0 to 39 do
            chksum:=(chksum + header[tempi]) mod 256;
            IF CHksum <> 58 then
            begin
              messagebox ('Wrong Checksum. Please contact Wallace Wadge', nil, mferror+mfokbutton);
              exit;
            end;
              UploadDialog (false);
              siorxflush (comport);
          end;

        cmdownedit:
  begin
       case configvar.parity of     {one stop bit now !}
      0: SioParms (comport, evenparity, onestopbit, wordlength8);
      1: SioParms(comport, oddparity, onestopbit, wordlength8);
      2: SioParms(comport, noparity, onestopbit, wordlength8);
    end;
            fillchar (header, sizeof(header), #255);
            fillchar (prog, sizeof(prog), #255);
            one:=true;
            DoDownDialog;
            s:='';
            if allok = false then exit;
  if calctype = cfx9800 then
   begin
   for tempi:=8 to 19 do
     if header[tempi] <> 255 then
       if upcase(chr(header[tempi])) in ['A'..'Z', '0'..'9', '-'] then
         s:=s+chr(header[tempi]);
   end else
   begin
   for tempi:=11 to 18 do
     if header[tempi] <> 255 then
       if upcase(chr(header[tempi])) in ['A'..'Z', '0'..'9', '-'] then
         s:=s+chr(header[tempi]);
   end;
          s:=s+'.LNK';
          repeat
          if EditorDialog(edSaveAs, @s) = cmCancel then exit;
            assign (textfile, s);
            {$I-}
            reset (textfile);
            tempb:=ioresult;
            if tempb = 2 then
              begin
                rewrite (textfile);
                tempb:=0;
              end else if tempb = 0 then
                begin
                  result:=messagebox ('File already exists. Overwrite?', nil, mfconfirmation+mfyesbutton+
                  mfnobutton);
                  if result = cmyes then
                    begin
                      rewrite (textfile);
                      tempb:=0;
                    end else exit;
                end;
          until tempb=0;
            parsefile;
            openeditor (s, true);
          end;
        cmdownalledit:
          begin
          case configvar.parity of
      0: SioParms (comport, evenparity, onestopbit, wordlength8);
      1: SioParms(comport, oddparity, onestopbit, wordlength8);
      2: SioParms(comport, noparity, onestopbit, wordlength8);
    end;
    
            fillchar (header, sizeof(header), #255);
            fillchar (prog, sizeof(prog), #255);
            one:=false;
            DoDownDialog;
         end;
        cmupmultipleedit:          {Upload multiple}
          begin
            case configvar.parity of  {one stop bit!}
      0: SioParms (comport, evenparity, onestopbit, wordlength8);
      1: SioParms(comport, oddparity, onestopbit, wordlength8);
      2: SioParms(comport, noparity, onestopbit, wordlength8);
      end;
          upmultiple;
        end;
        cmprocessmultiple:
          begin
            case configvar.parity of
      0: SioParms (comport, evenparity, onestopbit, wordlength8);
      1: SioParms(comport, oddparity, onestopbit, wordlength8);
      2: SioParms(comport, noparity, onestopbit, wordlength8);
      end;
        multipleup;
    end;
        cmreadnow: readstuff (false, globals);    {Read the file}
        cmconvert:
          begin
            result:=messagebox ('Attempt to translate text to symbols ?', nil, mfconfirmation+mfyesbutton+
            mfnobutton);
            if result <> cmyes then exit;
          for j:=14 downto 2 do
           for i:=0 to tempcollection^.count-1 do {With longest first}
             if length(pstring(tempcollection^.at(i))^) = j then
             begin
               message (edit, evkeydown, kbctrlpgup, nil);
               if pstring(tempcollection^.at(i))^[length(pstring(tempcollection^.at(i))^)]= ' '
               then findstr:=copy (pstring(tempcollection^.at(i))^, 1, length(pstring(tempcollection^.at(i))^)-1)
               else
               FindStr := pstring(tempcollection^.at(i))^;
               ReplaceStr := '$'+pstring(tempcollection^.at(i))^+'$';
               EditorFlags := efDoReplace+efreplaceall+efwholewordsonly;
               if findstr <> '' then
               message (edit, evcommand, cmsearchagain, nil);
            end;

            {Special cases}
               searchandreplace ('PLOT$ ', 'PLOT$', efDoReplace+efreplaceall);
               searchandreplace ('GOTO $ ', 'GOTO $', efDoReplace+efreplaceall);
               searchandreplace ('LBL $ ', 'LBL $', efDoReplace+efreplaceall);
               searchandreplace ('DSZ $ ', 'DSZ $', efDoReplace+efreplaceall);
               searchandreplace ('ISZ $ ', 'ISZ $', efDoReplace+efreplaceall);
               searchandreplace ('RANGE $ ', 'RANGE $', efDoReplace+efreplaceall);
	       searchandreplace ('=<', '$=<$', efDoReplace+efreplaceall);
               searchandreplace ('<=', '$<=$', efDoReplace+efreplaceall);
               searchandreplace ('<>', '$<>$', efDoReplace+efreplaceall);
               searchandreplace ('>=', '$>=$', efDoReplace+efreplaceall);
               searchandreplace ('=>', '$=>$', efDoReplace+efreplaceall);
               searchandreplace ('->', '$->$', efDoReplace+efreplaceall);
               searchandreplace ('/', '$/$', efDoReplace+efreplaceall);
               searchandreplace ('^2', '$^2$', efDoReplace+efreplaceall);
               searchandreplace ('^1/X', '$^1/X$', efDoReplace+efreplaceall);
               searchandreplace ('^0.5', '$^0.5$', efDoReplace+efreplaceall);
               searchandreplace ('^1/3', '$^1/3$', efDoReplace+efreplaceall);
               searchandreplace ('^-1', '$^-1$', efDoReplace+efreplaceall);
               searchandreplace ('_|', '$_|$', efDoReplace+efreplaceall);
          end;
        cminsertsymbol:    {Inserts text}
          begin
            if (desktop^.current = nil) and (fname='') then exit;
            result:=executedialog (makesymbolbox, nil);
            if result = cmcancel then exit;
            temps:=(psymbolist(sendlist^.at(dchoosesymbox^.focused))^.name)^;
            if ((temps = '+') or (temps = '-') or (temps = '*') or (temps='!')) =false then
            insertsymtext:='$'+(psymbolist(sendlist^.at(dchoosesymbox^.focused))^.name)^+'$' else
            insertsymtext:=(psymbolist(sendlist^.at(dchoosesymbox^.focused))^.name)^;
            if insertsymtext[2] = '$' then delfixsym (insertsymtext);
            message (edit, evcommand, 199, nil);
          end;
        cmabout: executedialog (makedialog, nil);
        cmwindows: messagebox ('You are currently using Windoze. If you encounter problems, try quitting that crap and try '+
        'again.', nil, mfwarning+mfokbutton);
      else
        Exit;
      end;
  else
    Exit;
  end;
  ClearEvent(Event);
end;

procedure Tcasioapp.InitMenuBar;
{Constructs the menu bar}
var
  R: TRect;
begin
  GetExtent(R);
  R.B.Y := R.A.Y + 1;
  MenuBar := New(PMenuBar, Init(R, NewMenu(
    NewSubMenu('~F~ile', hcNoContext, NewMenu(
      StdFileMenuItems(
      nil)),
    NewSubMenu('~E~dit', hcNoContext, NewMenu(
      StdEditMenuItems(
      NewLine(
      NewItem('~S~how clipboard', '', kbNoKey, cmShowClip, hcnocontext,
      NewItem('~I~nsert Symbol', '', kbf7, cminsertsymbol, hcNoContext,
      nil))))),
    NewSubMenu('~S~earch', hcNoContext, NewMenu(
      NewItem('~F~ind...', '', kbNoKey, cmFind, hcNoContext,
      NewItem('~R~eplace...', '', kbNoKey, cmReplace, hcNoContext,
      NewItem('~S~earch again', '', kbNoKey, cmSearchAgain, hcNoContext,
      NewItem('~T~ranslate to calculator', '', kbNoKey, cmconvert, hcNoContext,
      nil))))),
    NewSubMenu('~W~indows', hcNoContext, NewMenu(
      NewItem('~T~ile', '', kbNoKey, cmTile, hcTile,
    NewItem('C~a~scade', '', kbNoKey, cmCascade, hcCascade,
    NewLine(
    NewItem('~S~ize/Move','Ctrl+F5', kbCtrlF5, cmResize, hcResize,
    NewItem('~Z~oom', 'F5', kbF5, cmZoom, hcZoom,
    NewItem('~N~ext', 'F6', kbF6, cmNext, hcNext,
    NewItem('~P~revious', 'Shift+F6', kbShiftF6, cmPrev, hcPrev,
    NewItem('~C~lose', 'Alt+F3', kbAltF3, cmClose, hcClose,
      nil))))))))),
    newsubmenu ('~L~ink-Up', hcnocontext, newmenu(
      newsubmenu ('~T~ransmit', hcnocontext, newmenu(
        newitem ('~E~ditor file', '', kbnokey, cmupedit, hcnocontext,
        newitem ('~P~rogramme file', '', kbnokey, cmupprog, hcnocontext,
        newitem ('~A~ll/Multiple editor files', '', kbnokey, cmupmultipleedit, hcnocontext,
      nil)))),
      newsubmenu ('~R~eceive', hcnocontext, newmenu(
        newitem ('~E~ditor/progamme file', '', kbnokey, cmdownedit, hcnocontext,
        newitem ('~A~ll/Multiple editor files', '', kbnokey, cmdownalledit, hcnocontext,
      nil))),
     newitem ('~A~bout', '', kbnokey, cmabout, hcnocontext,
      newitem ('~S~etup', '', kbnokey, cmsetup, hcnocontext,
nil))))),
    nil))))))));
end;

procedure Tcasioapp.InitStatusLine;
{Constructs the status line}
var
  R: TRect;
begin
  GetExtent(R);
  R.A.Y := R.B.Y - 1;
  New(StatusLine, Init(R,
    NewStatusDef(0, $FFFF,
      NewStatusKey('~Alt-X~ Exit', kbaltx, cmquit,
      NewStatusKey('~F2~ Save', kbF2, cmSave,
      NewStatusKey('~F3~ Open', kbF3, cmOpen,
      NewStatusKey('~Alt-F3~ Close', kbAltF3, cmClose,
      NewStatusKey('~F5~ Zoom', kbF5, cmZoom,
      NewStatusKey('~F6~ Next', kbF6, cmNext,
       Newstatuskey('~F7~ Symbols', kbf7, cminsertsymbol,
      NewStatusKey('~F10~ Menu', kbF10, cmMenu,
      NewStatusKey('', kbCtrlF5, cmResize,
      nil))))))))),
    nil)));
end;

constructor tsymbolist.Init(newname: string; newrecpos: longint);
{Insert record fields in collection}
begin
  name := newstr(newname);
  new (recpos);
  recpos^:=newrecpos;
end;

constructor Tcasioapp.Init;
{Main initialize}
var
  i, H: Word;
  R: TRect;
begin
  MaxHeapSize := HeapSize; {For editor}
  inherited Init;
  getextent(r);
    localmenuopen:=false;
    eventmask:=eventmask or evbroadcast;
    Menu:= newmenu(
      newsubmenu ('~T~ransmit', hcnocontext, newmenu(
        newitem ('~E~ditor file', '', kbnokey, cmupedit, hcnocontext,
        newitem ('~P~rogramme file', '', kbnokey, cmupprog, hcnocontext,
        newitem ('~A~ll/Multiple editor files', '', kbnokey, cmupmultipleedit, hcnocontext,
      nil)))),
      newsubmenu ('~R~eceive', hcnocontext, newmenu(
        newitem ('~E~ditor/progamme file', '', kbnokey, cmdownedit, hcnocontext,
        newitem ('~A~ll/Multiple editor files', '', kbnokey, cmdownalledit, hcnocontext,
      nil))),
      NewItem('~I~nsert Symbol', '', kbf7, cminsertsymbol, hcNoContext,
      NewItem('~T~ranslate to calculator', '', kbNoKey, cmconvert, hcNoContext,
      nil)))));


  DisableCommands([cmSave, cmSaveAs, cmCut, cmCopy, cmPaste, cmClear,
    cmUndo, cmFind, cmReplace, cmSearchAgain]); {not available yet}
  EditorDialog := StdEditorDialog;
  ClipWindow := OpenEditor('', false);
  if ClipWindow <> nil then
  begin
    Clipboard := ClipWindow^.Editor;
    Clipboard^.CanUndo := False;
  end;

  assign (configfile, 'link-up.cfg');
  {$I-}
  reset (configfile);
  if ioresult <> 0 then
    begin
      rewrite (configfile);
      configvar.port:=1;            {Set defaults}
      configvar.baud:=3;
      configvar.parity:=0;
      configvar.model:=0;
      configvar.delay:='0';
      write (configfile, configvar);
      message (application, evcommand, cmsetup, nil);  {Show setup if not
                                                found}
    end else read (configfile, configvar);
    initport;  {Open comport}
    if configvar.model = cfx9850 then disablecommands ([cmupprog]);
fillchar (prog, sizeof(prog), #255);
    redraw;
    fadein (4);
    message (application, evcommand, cmabout, nil);
    if windowscheck then message (application, evcommand, cmwindows, nil);
      sendlist:=new(psymbolcollection, init(198, 10));
      tempcollection:=new(pcollection, init (198, 10));
TempCollection^.Insert(Newstr('@'));
TempCollection^.Insert(Newstr('FEMTO'));
TempCollection^.Insert(Newstr('PICO'));
TempCollection^.Insert(Newstr('NANO'));
TempCollection^.Insert(Newstr('MICRO'));
TempCollection^.Insert(Newstr('MILLI'));
TempCollection^.Insert(Newstr('KILO'));
TempCollection^.Insert(Newstr('MEGA'));
TempCollection^.Insert(Newstr('GIGA'));
TempCollection^.Insert(Newstr('TERA'));
TempCollection^.Insert(Newstr('PETA'));
TempCollection^.Insert(Newstr('EXA'));
TempCollection^.Insert(Newstr('- DISP -'));
TempCollection^.Insert(Newstr('CR'));
TempCollection^.Insert(Newstr('->'));
TempCollection^.Insert(Newstr('EXP'));
TempCollection^.Insert(Newstr('=<'));
TempCollection^.Insert(Newstr('<>'));
TempCollection^.Insert(Newstr('>='));
TempCollection^.Insert(Newstr('=>'));
TempCollection^.Insert(Newstr('F1'));
TempCollection^.Insert(Newstr('F2'));
TempCollection^.Insert(Newstr('F3'));
TempCollection^.Insert(Newstr('F4'));
TempCollection^.Insert(Newstr('F5'));
TempCollection^.Insert(Newstr('F6'));
TempCollection^.Insert(Newstr('A'));
TempCollection^.Insert(Newstr('B'));
TempCollection^.Insert(Newstr('C'));
TempCollection^.Insert(Newstr('D'));
TempCollection^.Insert(Newstr('E'));
TempCollection^.Insert(Newstr('F'));
TempCollection^.Insert(Newstr('SIGMA'));
TempCollection^.Insert(Newstr('POL('));
TempCollection^.Insert(Newstr('SIN'));
TempCollection^.Insert(Newstr('COS'));
TempCollection^.Insert(Newstr('TAN'));
TempCollection^.Insert(Newstr('H (HEX)'));
TempCollection^.Insert(Newstr('LN'));
TempCollection^.Insert(Newstr('^0.5'));
TempCollection^.Insert(Newstr('-'));{(-)}
TempCollection^.Insert(Newstr('P'));
TempCollection^.Insert(Newstr('+')); {+}
TempCollection^.Insert(Newstr('XNOR'));
TempCollection^.Insert(Newstr('^2'));
TempCollection^.Insert(Newstr(''));
TempCollection^.Insert(Newstr('INTEGRAL('));
TempCollection^.Insert(Newstr('MOD'));
TempCollection^.Insert(Newstr('SIGMA X2'));
TempCollection^.Insert(Newstr('POL('));
TempCollection^.Insert(Newstr('SIN-1'));
TempCollection^.Insert(Newstr('COS-1'));
TempCollection^.Insert(Newstr('TAN-1'));
TempCollection^.Insert(Newstr('D (DEC)'));
TempCollection^.Insert(Newstr('LOG'));
TempCollection^.Insert(Newstr('^1/3'));
TempCollection^.Insert(Newstr('ABS'));
TempCollection^.Insert(Newstr('-')); {-}
TempCollection^.Insert(Newstr('XOR'));
TempCollection^.Insert(Newstr('^-1'));
TempCollection^.Insert(Newstr('DEGREES'));
TempCollection^.Insert(Newstr('INTEGRAL('));
TempCollection^.Insert(Newstr('MED'));
TempCollection^.Insert(Newstr('SIGMA X'));
TempCollection^.Insert(Newstr('REC('));
TempCollection^.Insert(Newstr('SINH'));
TempCollection^.Insert(Newstr('COSH'));
TempCollection^.Insert(Newstr('TANH'));
TempCollection^.Insert(Newstr('O (OCT)'));
TempCollection^.Insert(Newstr('E'));
TempCollection^.Insert(Newstr('INT'));
TempCollection^.Insert(Newstr('NOT'));
TempCollection^.Insert(Newstr('X^Y'));
TempCollection^.Insert(Newstr('*'{'*'}));
TempCollection^.Insert(Newstr('OR'));
TempCollection^.Insert(Newstr('!'));
TempCollection^.Insert(Newstr('R (RADIANS)'));
TempCollection^.Insert(Newstr('INTEGRAL('));
TempCollection^.Insert(Newstr('MIN'));
TempCollection^.Insert(Newstr('N'));
TempCollection^.Insert(Newstr('REC('));
TempCollection^.Insert(Newstr('SINH-1'));
TempCollection^.Insert(Newstr('COSH-1'));
TempCollection^.Insert(Newstr('TANH-1'));
TempCollection^.Insert(Newstr('B (BIN)'));
TempCollection^.Insert(Newstr('10^'));
TempCollection^.Insert(Newstr('FRAC'));
TempCollection^.Insert(Newstr('NEG'));
TempCollection^.Insert(Newstr('^1/X'));
TempCollection^.Insert(Newstr('$/$'{ DIVIDE'}));
TempCollection^.Insert(Newstr('AND'));
TempCollection^.Insert(Newstr('_|'));
TempCollection^.Insert(Newstr('G (GRADIANS)'));
TempCollection^.Insert(Newstr('INTEGRAL('));
TempCollection^.Insert(Newstr('MAX'));
TempCollection^.Insert(Newstr('SIGMA Y2'));
TempCollection^.Insert(Newstr('ANS'));
TempCollection^.Insert(Newstr('RAN#'));
TempCollection^.Insert(Newstr('MEAN X'));
TempCollection^.Insert(Newstr('MEAN Y'));
TempCollection^.Insert(Newstr('XON'));
TempCollection^.Insert(Newstr('XON-1'));
TempCollection^.Insert(Newstr('YON'));
TempCollection^.Insert(Newstr('YON-1'));
TempCollection^.Insert(Newstr('LR A'));
TempCollection^.Insert(Newstr('LR B'));
TempCollection^.Insert(Newstr('LR R'));
TempCollection^.Insert(Newstr('PEAK X'));
TempCollection^.Insert(Newstr('PEAK Y'));
TempCollection^.Insert(Newstr('R'));
TempCollection^.Insert(Newstr('THETA'));
TempCollection^.Insert(Newstr('SIGMA Y'));
TempCollection^.Insert(Newstr('PI'));
TempCollection^.Insert(Newstr('CLS'));
TempCollection^.Insert(Newstr('MCL'));
TempCollection^.Insert(Newstr('RND'));
TempCollection^.Insert(Newstr('DEC'));
TempCollection^.Insert(Newstr('HEX'));
TempCollection^.Insert(Newstr('BIN'));
TempCollection^.Insert(Newstr('OCT'));
TempCollection^.Insert(Newstr('SCL'));
TempCollection^.Insert(Newstr('NORM'));
TempCollection^.Insert(Newstr('DEG'));
TempCollection^.Insert(Newstr('RND'));
TempCollection^.Insert(Newstr('GRA'));
TempCollection^.Insert(Newstr('ENG'));
TempCollection^.Insert(Newstr('INTG'));
TempCollection^.Insert(Newstr('SIGMA XY'));
TempCollection^.Insert(Newstr('PLOT'));
TempCollection^.Insert(Newstr('LINE'));
TempCollection^.Insert(Newstr('LBL'));
TempCollection^.Insert(Newstr('FIX'));
TempCollection^.Insert(Newstr('SCI'));
TempCollection^.Insert(Newstr('DEFM'));
TempCollection^.Insert(Newstr('CL'));
TempCollection^.Insert(Newstr('DT'));
TempCollection^.Insert(Newstr('DSZ'));
TempCollection^.Insert(Newstr('ISZ'));
TempCollection^.Insert(Newstr('FACTOR'));
TempCollection^.Insert(Newstr('RANGE'));
TempCollection^.Insert(Newstr('GOTO'));
TempCollection^.Insert(Newstr('PROG'));
TempCollection^.Insert(Newstr('GRAPH Y='));
TempCollection^.Insert(Newstr('GRAPH INTEGRAL'));
TempCollection^.Insert(Newstr('GRAPH Y>'));
TempCollection^.Insert(Newstr('GRAPH Y<'));
TempCollection^.Insert(Newstr('GRAPH Y>='));
TempCollection^.Insert(Newstr('GRAPH Y <='));
TempCollection^.Insert(Newstr('GRAPH R='));
TempCollection^.Insert(Newstr('GRAPH (X, Y)='));
  TempCollection^.Insert(Newstr('P('));
  TempCollection^.Insert(Newstr('Q('));
  TempCollection^.Insert(Newstr('R('));
  TempCollection^.Insert(Newstr('T('));
  TempCollection^.Insert(Newstr('T('));
  TempCollection^.Insert(Newstr('T('));
  TempCollection^.Insert(Newstr('T('));
  TempCollection^.Insert(Newstr('T('));
  TempCollection^.Insert(Newstr('T('));
  for i:=0 to tempcollection^.count-1 do sendlist^.Insert(New(Psymbolist, Init(pstring(tempcollection^.at(i))^, i)));
end;

procedure tcasioapp.idle;
begin
  inherited idle;
  {Is there a file open???}
  if (desktop^.current = nil) and (fname='') then disablecommands ([cminsertsymbol, cmconvert, cmtile, cmcascade]) else
  enablecommands ([cminsertsymbol, cmconvert, cmtile, cmcascade]);
end;

procedure Tcasioapp.OutOfMemory;
begin
  MessageBox('Not enough memory for this operation.',
    nil, mfError + mfOkButton);
end;

var xcur, ycur: byte;
    i: word;
    sd:pcollection;
begin
  if paramstr(1) = '/?' then
    begin
      writeln ('Type Link-up /nofade for no fade crap');
      halt;
    end;
  xcur:=wherex;
  ycur:=wherey;
  savescreen;
  {$IFNDEF LOCAL}
  if upstr(paramstr (1)) <> '/NOFADE' then fadeout (3);
  {$ENDIF}
  casioapp.Init;
  casioapp.Run;
{$IFNDEF LOCAL}
  if upstr(paramstr (1)) <> '/NOFADE' then fadeout (7);
  {$ENDIF}
  casioapp.Done;

  for i:=0 to tempcollection^.count-1 do
    disposestr (tempcollection^.at(i));
  dispose (tempcollection);
  dispose (sendlist, done);
  restorescreen;
  gotoxy (xcur, ycur);
  fadein (4);
  close (configfile);
  siodone (comport);
end.
